ThreadPoolExecutor.DiscardOldestPolicy (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util.concurrent, class: ThreadPoolExecutor, class: DiscardOldestPolicy
Keywords: java.util.concurrent.ThreadPoolExecutor.DiscardOldestPolicy class

# Class ThreadPoolExecutor.DiscardOldestPolicy

java.lang.Object
java.util.concurrent.ThreadPoolExecutor.DiscardOldestPolicy

All Implemented Interfaces:
  `RejectedExecutionHandler`

Enclosing class:
  `ThreadPoolExecutor`

public static class ThreadPoolExecutor.DiscardOldestPolicy extends Object implements RejectedExecutionHandler
A handler for rejected tasks that discards the oldest unhandled request and then retries `execute`, unless the executor is shut down, in which case the task is discarded. This policy is rarely useful in cases where other threads may be waiting for tasks to terminate, or failures must be recorded. Instead consider using a handler of the form:

    new RejectedExecutionHandler() {
      public void rejectedExecution(Runnable r, ThreadPoolExecutor e) {
        Runnable dropped = e.getQueue().poll();
        if (dropped instanceof Future<?>) {
          ((Future<?>)dropped).cancel(false);
          // also consider logging the failure
        }
        e.execute(r);  // retry
    }}

Since:
  1.5

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DiscardOldestPolicy()`
  Creates a `DiscardOldestPolicy` for the given executor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `rejectedExecution(Runnable r, ThreadPoolExecutor e)`
  Obtains and ignores the next task that the executor would otherwise execute, if one is immediately available, and then retries execution of task r, unless the executor is shut down, in which case task r is instead discarded.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### DiscardOldestPolicy

    public DiscardOldestPolicy()
    Creates a `DiscardOldestPolicy` for the given executor.

- ## Method Details

  - ### rejectedExecution

    public void rejectedExecution(Runnable r, ThreadPoolExecutor e)
    Obtains and ignores the next task that the executor would otherwise execute, if one is immediately available, and then retries execution of task r, unless the executor is shut down, in which case task r is instead discarded.
    Specified by:
      `rejectedExecution` in interface `RejectedExecutionHandler`
    Parameters:
      `r` - the runnable task requested to be executed
      `e` - the executor attempting to execute this task